//May.23.2005
//Tak.Sugawara 
//Generic RAM module  for Tariq-san and others
//
module gen_ram #(parameter hex_file="code0.h",//hex file
				 parameter integer ram_address_bits=12)//ram address space
   (
	input [7:0] data_b,
	input wren_b,//wr
	input [ram_address_bits-1:0] address_a, 	address_b,
	input clock,
	output [7:0] q_a, q_b);

	reg [ram_address_bits-1:0] address_a_reg,address_b_reg;//address register
	reg [7:0] mem [0:2**ram_address_bits-1];//actual memory

	reg [100*8:1] mem_file_name;//temporay file name for verilog converted

//address_a_reg
	always @ (posedge clock) begin
		address_a_reg<=address_a;
	end

//adress_b_reg
	always @ (posedge clock) begin
		address_b_reg<=address_b;
	end

//read operation
	assign q_a= mem[address_a_reg];
	assign q_b= mem[address_b_reg];

//write operatiion
	always @(posedge clock) begin
		if (wren_b) mem[address_b]<=data_b;
	end

//memory initialization
	initial begin
	      $convert_hex2ver(hex_file, 8, mem_file_name);//convert hex file to verilog format
            $readmemh(mem_file_name, mem);//read memory description 
	end

endmodule

